
#define T0  273.16				  
#define K   0.2                   //ֹܹܱڱĵԴֲڶ

#include <math.h>


//ŵ
//ڲdQ-(m3/h); lDN-ܵھ(mm); dLȼܵ㳤(m);
//ڲdRe-ŵ.
//ֵ  0 ڲΪ0ʧ; 1 ɹ.
short Gas_count_Re(double dQ, double lDN, double dV, double dL, double* dRe)
{
	if(dQ<=0 || lDN<=0 || dV<=0 || dL<=0)
		return 0;
	*dRe = 4*dQ / (3.1415926*lDN*dL*dV);

	return 1;

}



//////////////////////////////////////////////////////////////////////////
///////////////////////Ħϵ///////////////////////////////////
//////////////////////////////////////////////////////////////////////////

//ѹ״̬Ħϵ(Coefficient of Friction)
//ڲdRe-ŵ
//ڲdCF-Ħϵ.
//ֵ  0 ڲΪ0ʧ; 1 ɹ.
short Gas_Count_Low_Laminar_Flow_CF(double dRe, double* dCF)
{
	if(dRe <= 0)
		return 0;
	*dCF = 64/dRe;
	
	return 1;	
}

//ѹٽ״̬Ħϵ(Coefficient of Friction)
//ڲdRe-ŵ
//ڲdCF-Ħϵ.
//ֵ  0 ڲΪ0ʧ; 1 ɹ.
short Gas_Count_Low_Critical_CF(double dRe, double* dCF)
{
	if(dRe<=2100 || dRe >3500)
		return 0;
	*dCF = 0.03 + (dRe-2100)/(65*dRe - pow(10,5));
	
	return 1;	
}

//ѹ(иѹ)״ֹ̬ܵĦϵ(Coefficient of Friction)
//ڲlDN-ܵھ(mm)dRe-ŵdKܱڱĵԴֲڶ
//			
//ڲdCF-Ħϵ.
//ֵ  0 ڲΪ0ʧ; 1 ɹ.
short Gas_Count_Steel_CF(double lDN, double dRe, double dK, double* dCF)
{
	if(lDN<=0 || dRe<=0 || dK<=0)
		return 0;
	*dCF = 0.11*pow(dK/lDN + 68/dRe, 0.25);
	
	return 1;	
}


//ѹ(иѹ)״̬ܵĦϵ(Coefficient of Friction)
//ڲlDN-ܵھ(mm)dQ-(m3/h)dV-˶
//						
//ڲdCF-Ħϵ
//ֵ  0 ڲΪ0ʧ; 1 ɹ.
short Gas_Count_Cas_Iron_CF(double lDN, double dQ, double dV, double* dCF)
{
	if(lDN<=0 || dQ<=0 || dV<=0)
		return 0;
	*dCF = 0.102236 * pow(1/(double)lDN + 5158* (lDN*dV/dQ), 0.284);
	
	return 1;	
}


//////////////////////////////////////////////////////////////////////////
///////////////////ȼܵλȵĦʧ/////////////////////
//////////////////////////////////////////////////////////////////////////

//ѹȼܵĦʧ
//ڲdL-㳤(m); dQ-(m3/h); lDN-ܵھ(mm); 
//			dV-0Ⱥ101.325kPaʱ˶(m2/s); dDE-ȼܶ(kg/m3); dT-ȼ¶(K).	
//ڲdHeadLoss-Ħʧ(Pa).
//ֵ  0 ڲΪ0ʧܣ1 ɹ.
short gas_count_Low_Laminar_Flow(double dL, double dQ, double lDN, double dV, double dDE, double dT, double* dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)
		return 0;
	* dHeadLoss = 1.13 * pow(10, 10) * (dQ / pow(lDN, 4)) * dV * dDE * (dT/T0) * dL;
	return 1;
}


//ѹٽ״̬ȼܵĦʧ
//ڲdL-㳤(m); dQ-(m3/h); lDN-ܵھ(mm); 
//			dV-0Ⱥ101.325kPaʱ˶(m2/s); dDE-ȼܶ(kg/m3); dT-ȼ¶(K)
//ڲdHeadLoss-Ħʧ(Pa)
//ֵ  0 ڲΪ0ʧ; 1 ɹ
short gas_count_Low_Critical(double dL, double dQ, double lDN, double dV, double dDE, double dT, double * dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)	
		return 0;
	* dHeadLoss = 1.9*pow(10, 6) * (1 + (11.8*dQ - 7*pow(10, 4)*lDN*dV) / (23*dQ - pow(10,5)*lDN*dV)) * (pow(dQ, 2)/pow(lDN, 5))  * dDE * (dT/T0) * dL;
	return 1;	
}


//ѹ״ֹ̬ȼܵĦʧ
//ڲdL-㳤(m); dQ-(m3/h); lDN-ܵھ(mm); dV-0Ⱥ101.325kPaʱ˶(m2/s); 
//			dDE-ȼܶ(kg/m3); dT-ȼ¶(K); dKܱڱĵԴֲڶ 
//ڲdHeadLoss-Ħʧ(Pa).
//ֵ  0 ڲΪ0ʧܣ1 ɹ.
short gas_count_Low_Overfall_Steel(double dL, double dQ, double lDN, double dV, double dDE, double dT, double dK, double * dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)
		return 0;
	* dHeadLoss = 6.9*pow(10, 6) * pow((dK/lDN + 192.2*(lDN*dV) / dQ), 0.25) * pow(dQ,2)/pow(lDN,5) * dDE * (dT/T0) * dL;
	return 1;	
}


//ѹ״̬ȼܵĦʧ
//ڲdQ-(m3/h); lDN-ܵھ(mm); 
//			dDE-ȼܶ(kg/m3); dT-ȼ¶(K).
//ڲdHeadLoss-Ħʧ(Pa).
//ֵ  0 ڲΪ0ʧܣ1 ɹ.
short gas_count_Low_Cas_Iron(double dL, double dQ, double lDN, double dV, double dDE, double dT, double * dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)
		return 0;

	* dHeadLoss = 6.4*pow(10,6) * pow((1/lDN + 5158*lDN*dV / dQ), 0.248) * pow(dQ,2)/pow(lDN,5) * dDE * (dT/T0) * dL;
	return 1;
	
}


//ѹֹȼܵĦʧ
//ڲdQ-(m3/h); lDN-ܵھ(mm);  
//			dDE-ȼܶ(kg/m3); dT-ȼ¶(K).
//ڲdHeadLoss-Ħʧ(Pa).
//ֵ  0 ڲΪ0ʧܣ1 ɹ.
short gas_count_High_Overfall_Steel(double dL, double dQ, double lDN, double dV, double dDE, double dT, double dK, double * dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)
		return 0;
	
	//* dHeadLoss =1000 * sqrt(1.4*pow(10, 9) * pow((dK/lDN + 192.2*(lDN*dV)/ dQ), 0.25) * pow(dQ,2)/pow(lDN,5)* dDE *(dT/T0) * (dL/1000));
	*dHeadLoss = 1.4*pow(10, 9) * pow((dK/lDN + 192.2*(lDN*dV)/dQ), 0.25) * pow(dQ,2)/pow(lDN,5)* dDE *(dT/T0) * (dL/1000);
	return 1;
	
}


//ѹȼܵĦʧ
//ڲdQ-(m3/h); lDN-ܵھ(mm); 
//			dDE-ȼܶ(kg/m3); dT-ȼ¶(K).
//ڲdHeadLoss-Ħʧ(Pa).
//ֵ  0 ڲΪ0ʧܣ1 ɹ.
short gas_count_High_Cas_Iron(double dL, double dQ, double lDN, double dV, double dDE, double dT, double * dHeadLoss)
{
	if(dL<=0 || dQ<=0 || lDN<=0 || dV<=0 || dDE<=0 || dT<=0)		
		return 0;
	
//	* dHeadLoss = 1000 * sqrt(1.3*pow(10,9) * pow((1/lDN + 5158*lDN*dV / dQ), 0.284) * pow(dQ,2)/pow(lDN,5) * dDE * (dT/T0) * (dL/1000));
	* dHeadLoss = /*1000 **/ 1.3*pow(10,9) * pow((1/lDN + 5158*lDN*dV / dQ), 0.284) * pow(dQ,2)/pow(lDN,5) * dDE * (dT/T0) * (dL/1000);
	return 1;
	
}


