#pragma once
#include <map>
#include <string>
#include <vector>

class CivDbConn;

#define CACHEEXPORT __declspec(dllexport)
// ڵ
typedef struct 
{
	std::string sNo; // 
	std::string xCoord; // x
	std::string yCoord; // y
} Junctions;

// ܶ
typedef struct
{
	std::string sNo; // 
	std::string startX; // ʼڵx
	std::string startY; // ʼڵY
	std::string endX;// ֹڵX
	std::string endY;// ֹڵY
}Pipes;

/**
*׷ٽڵ㣬ܶϢ
*/
class CACHEEXPORT CivTrackingResultCache
{
public:
	/**
	*@brief ݿϢ
	*@param dbConn ݿ
	*/
	void cacheInfoFromDb(CivDbConn* dbConn);

	/**
	*@brief Ϣתjsonַ
	*@param jsonStr תĽֵ
	*/
	void transformToJsonStr(std::string jsonStr);

	/**
	*@brief ݱŻȡڵϢ
	*@param sn 
	*@param junctions, ȡĽڵϢ
	*/
	void getNodeInfoBySn(const std::string& sn, Junctions& junctions);

	/**
	*@brief ݱŻȡܶϢ
	*@param sn 
	*@param junctions, ȡĹܶϢ
	*/
	void getPipeInfoBySn(const std::string& sn, Pipes& pipes);

private:
	/**
	 *@brief ݿĽڵ
	 *@param dbConn ݿ
	 */
	void cacheJunctionInfoFromDb(CivDbConn* dbConn);

	/**
	*@brief ݹܶϢ
	*@param dbConn 
	*/
	void cachePipeInfoFromDb(CivDbConn* dbConn);

private:
	std::map<std::string, Junctions> mNodeCache; // ڵϢ
	std::map<std::string, Pipes> mPipesCache;// ܶϢ
};
