#pragma once
#include "CivSimulResultCache.h"
#include "CivNewInp.h"

class CivDbConn;
/**
ˮģ
*/
class CivHydrSimulation
{
public:
	explicit CivHydrSimulation();
	explicit CivHydrSimulation(CivDbConn* dbConn);
	~CivHydrSimulation();

	/**
	 *@brief עݿ
	 *@param dbConn ݿָ
	 */
	void registDb(CivDbConn* dbConn);

	/**
	*@brief ˮģ
	*/
	bool hdyrSimulation();

	/**
	*@brief ˮģ⣬ˮ䣬ѧ
	*/
	bool qualitySimulation();

	/**
	*@brief ȡ
	*@return ַ
	*/
	std::string getAnalysisResults();

	/**
	*@brief ׷ٷȻʽˮʷ
	*@param snNode׷ٵĽڵ
	*@param hours: Сʱ
	*/
	bool trackingSimulation(char* snNode, int hours);

	/**
	*@brief inpļ
	*@param analyType: ˮʷͣˮ䣬׷٣none
	*@param qulityName:  ׷ٽڵֵ߻
	*/
	bool convertInp(const QualityAnalyType analyType, const std::string& qulityName);

	/**
	*@brief ȡ׷ٽֵ
	*@param hours׷ٵСʱ
	*/
	void getTrackingResult(int hours, std::string& result);

	/**
	*@brief ͬһֻһģĽֵǰ֮ǰģĽֵ
	*@param dbConn: ݿӶָ
	*@param date: 
	*/
	bool  clearSamePeriodValue(CivDbConn* dbConn, const std::string& date);

	/**
	*@brief ʱģݵgisģУĬϸʱ
	*@param dbConn: ݿӶָ
	*@param time: ʱ
	*/
	bool updateLastestDataToGisNet(CivDbConn* dbConn,const std::string& time);

	/**
	*@brief ˢµģ
	*/
	bool brushingResult();

	void setQualityAnalyType(QualityAnalyType analyType) { mQuaLityType = analyType; }

	/*
		inpļļļúͻȡ
	*/	
	inline void setInpFile(const std::string& inpFile);
	inline void setRptFile(const std::string& rptFile);	
	inline void setBinFile(const std::string& binFile);

private:
	inline char* getRptFile();
	inline char* getInpFile();
	inline char* getBinFile();

	/**
	*@brief ˮʼ
	*/
	bool qualityCompute();
	void getNodeResult(short time);
	void getLinkResult(short time);
    void getNodeQuality(short time);
    void getLinkQuality(short time);

private:
	CivDbConn* mDbConn;
	CivSimulResultCache mResultCache; // 洢ģ
	QualityAnalyType mQuaLityType = ANALYSIS_RESERVE;
	std::string mInpFile; // inpļ
	std::string mRptFile; // ļ
	std::string mBinFile;// ļ
};
