#ifndef CIVSIMULRESULTCACHE_H
#define CIVSIMULRESULTCACHE_H

#include <map>
#include "CivDbConn.h"
#include "CivDbConnection.h"
#include "CivTypes.h"

/**
     ģ
*/
class CivSimulResultCache
{
public:
	/**
	*@brief ڵˮ
	*@param quality洢ֵ
	*@param intervalģڼ
	*@param sNo
	*/
	void addNodeQuality(float quality, int interval, Str sNo);

	/**
	*@brief ˮ
	*@param quality洢ֵ
	*@param intervalģڼ
	*@param sNo߱
	*/
	void addLinkQuality(float quality, int interval, Str sNo);

	/**
	*@brief ڵˮģ
	*@param nodeItemڵˮֵ
	*/
	void addNodeItems(const NodeResultItem& nodeItem);

	/**
	*@brief ˮģ
	*@param linkItemģ
	*/
	void addLinkItems(const LinkResultItem& linkItem);

	/**
	*@brief ͷŻĽֵ
	*/
	void clear();

	/**
	*@brief ݸµݿ
	*@param dbConnݿӶ
	*/
	bool updateToDb(CivDbConnection* dbConn);

	bool updateToDb(CivDbConn* dbConn);

	/**
	*@brief ʱλȡ
	*@param time ʱ
	*@param nodeItems ڵֵ
	*@param linkItems ֵ
	*/
	void getResultByTime(int time, NodeResultItems& nodeItems, LinkResultItems& linkItems);

private:
	std::map<int, NodeResultItems> mNodeItemsMap; // ģ
	std::map<int, LinkResultItems> mLinkItemsMap; // 
};
#endif // !CIVSIMULRESULTCACHE_H
